@Echo off
REM ~[960206] 24-nov-96 Bert Rector
REM ~ IDCNINST.OVL does not exist anymore do not delete
REM ~[970174] 03-Feb-98 Marius Groenendijk & Peter de Vos
REM ~ Enable installation from hard-drive in stead of from floppies.
REM ~ This is relevant when installing an installation downloaded from the Internet.
REM ~[980086] 20-Mar-98 Marius Groenendijk
REM ~ Enable installation from CD-ROM.
REM ~[980037] 20-Mar-98 Marius Groenendijk
REM ~ On some systems (e.g. NT) it's just not possible to create a directory in \
REM ~ Allow alternate temporary directory
REM ~[980242] 28-Oct-98 Marius Groenendijk
REM ~ HHD Installation does not terminate if wrong parameters given
REM ~[990056] 3-May-1999 Marius Groenendijk
REM ~Device selection in Install procedure.
REM ************************************************************************
REM       Validation of INSTALL input parameter 1
REM ************************************************************************

REM ~[970174] Unpack self-extracting CORE and CN8 chunks file if available
REM Cannot use FOR ... on some systems.
IF EXIST CORE.EXE CORE.EXE -o >NUL
IF EXIST CORE.EXE DEL CORE.EXE >NUL
IF EXIST CN8_1_6.EXE CN8_1_6.EXE -o >NUL
IF EXIST CN8_2_6.EXE CN8_2_6.EXE -o >NUL
IF EXIST CN8_3_6.EXE CN8_3_6.EXE -o >NUL
IF EXIST CN8_4_6.EXE CN8_4_6.EXE -o >NUL
IF EXIST CN8_5_6.EXE CN8_5_6.EXE -o >NUL
IF EXIST CN8_6_6.EXE CN8_6_6.EXE -o >NUL
IF EXIST CN8_?_6.EXE DEL CN8_?_6.EXE >NUL

IF %3x == x GOTO Firstcall
IF %3  == 1 GOTO StartInst

:Firstcall
IF %1x==x  GOTO ERROR
IF %1==A:  GOTO PARA1OK
IF %1==B:  GOTO PARA1OK
IF %1==a:  GOTO PARA1OK
IF %1==b:  GOTO PARA1OK

REM ~[970174] Check if current directory contains installable stuff
REM ---- Check for ZIP_DBT rather than ZIP_EX, in case of 'CN8-only' disk
REM ~[980242] (BadHdd iso ERROR)
IF NOT EXIST ZIP_DBT.ZIP GOTO BadHdd
IF NOT EXIST ZIP_DB.ZIP GOTO BadHdd

REM Looks like a HDD (or CDROM) installation, proceed ...

REM ~[970174] N/A
REM GOTO ERROR

:PARA1OK

REM ************************************************************************
REM       Validation if DISK 1 was entered as first installation disk
REM ************************************************************************

IF EXIST %1INSTALL.ZIP GOTO CONT
:DISK1
Cls

REM ~[970174]
IF NOT EXIST TEXT.BAT GOTO BadInst

REM ~[980242] Make better check on availability of installation
REM If from floppy ...
IF %1==A:  GOTO FlopMsg
IF %1==B:  GOTO FlopMsg
IF %1==a:  GOTO FlopMsg
IF %1==b:  GOTO FlopMsg

REM ELSE it is HDD or CD
GOTO HddChk

REM If from floppy retry another diskette. Must interrupt with ^C
:FlopMsg
CALL  TEXT 1
PAUSE
IF NOT EXIST %1INSTALL.ZIP GOTO DISK1

REM If from floppy then so far so good
IF %1==A:  GOTO CONT
IF %1==B:  GOTO CONT
IF %1==a:  GOTO CONT
IF %1==b:  GOTO CONT

REM For HDD or CD instead of retrying another floppy, bail out.
:HddChk
IF NOT EXIST %1ZIP_DBT.ZIP GOTO BadHdd
IF NOT EXIST %1INSTALL.ZIP GOTO BadHdd
IF NOT EXIST %1ZIP_DB.ZIP GOTO BadHdd


:CONT

REM ************************************************************************
REM       Validation of INSTALL input parameter 2
REM ************************************************************************

REM **** Invalid destination drive (you cannot install on floppy) **********

IF %2x==x GOTO ERROR
IF %2==A: GOTO ERROR
IF %2==B: GOTO ERROR
IF %2==a: GOTO ERROR
IF %2==b: GOTO ERROR

IF %2==c: GOTO PARA2OK
IF %2==d: GOTO PARA2OK
IF %2==e: GOTO PARA2OK
IF %2==f: GOTO PARA2OK
IF %2==g: GOTO PARA2OK
IF %2==h: GOTO PARA2OK
IF %2==i: GOTO PARA2OK
IF %2==j: GOTO PARA2OK
IF %2==k: GOTO PARA2OK
IF %2==l: GOTO PARA2OK
IF %2==m: GOTO PARA2OK
IF %2==n: GOTO PARA2OK
IF %2==o: GOTO PARA2OK
IF %2==p: GOTO PARA2OK
IF %2==q: GOTO PARA2OK
IF %2==r: GOTO PARA2OK
IF %2==s: GOTO PARA2OK
IF %2==t: GOTO PARA2OK
IF %2==u: GOTO PARA2OK
IF %2==v: GOTO PARA2OK
IF %2==w: GOTO PARA2OK
IF %2==x: GOTO PARA2OK
IF %2==y: GOTO PARA2OK
IF %2==z: GOTO PARA2OK

IF %2==C: GOTO PARA2OK
IF %2==D: GOTO PARA2OK
IF %2==E: GOTO PARA2OK
IF %2==F: GOTO PARA2OK
IF %2==G: GOTO PARA2OK
IF %2==H: GOTO PARA2OK
IF %2==I: GOTO PARA2OK
IF %2==J: GOTO PARA2OK
IF %2==K: GOTO PARA2OK
IF %2==L: GOTO PARA2OK
IF %2==M: GOTO PARA2OK
IF %2==N: GOTO PARA2OK
IF %2==O: GOTO PARA2OK
IF %2==P: GOTO PARA2OK
IF %2==Q: GOTO PARA2OK
IF %2==R: GOTO PARA2OK
IF %2==S: GOTO PARA2OK
IF %2==T: GOTO PARA2OK
IF %2==U: GOTO PARA2OK
IF %2==V: GOTO PARA2OK
IF %2==W: GOTO PARA2OK
IF %2==X: GOTO PARA2OK
IF %2==Y: GOTO PARA2OK
IF %2==Z: GOTO PARA2OK

GOTO ERROR

REM **** Inexisting destination drive (syntax error or inexisting drive) ***
REM **** if the temporary directory could not be created and PKUNZIP *******
REM **** not copied into the directory *************************************

:PARA2OK


REM ~[970174]
IF NOT EXIST ZIP_DB.ZIP GOTO NoHDD
REM *** Looks like a HDD or CDROM installation
REM unless it's a floppy (tweaked...) in which case we go back to normal floppy based
REM installation
IF %1==A: GOTO NoHDD
IF %1==B: GOTO NoHDD
IF %1==a: GOTO NoHDD
IF %1==b: GOTO NoHDD

REM ~[980086] test for IDEP-CDROM identification.
REM ~ This is a special 'marker-file' called IDEPCN8.ROM (!)
REM ~ We consider a CD-ROM to be a 'large' Floppy. Install as if from floppy.
IF NOT EXIST IDEPCN8.ROM GOTO HDDOk
IF %1x == %2x GOTO CDNotOK
GOTO NoHDD

:HDDOk
REM HDD installation; proceed (in current dir)
Md XXXYYYZZ.III  > NUL
Cd XXXYYYZZ.III  > NUL
COPY ..\PKUNZIP.EXE  > NUL
IF NOT EXIST PKUNZIP.EXE GOTO ERROR2

REM ************************************************************************
REM       Installation of application
REM ************************************************************************

CLS

COPY ..\INSTALL.BAT > NUL
COPY ..\TEXT.BAT    > NUL

REM ~[970174]
IF NOT EXIST TEXT.BAT GOTO BadInst

CALL TEXT 2

PKUNZIP -o -3 ..\INSTALL  > NUL
GOTO Proceed

REM *** Normal floppy installation (or CDROM) ***
:NoHDD
%2

REM ~[990056] If the 2nd arg is an illegal drive we're still in the same directory.
REM Test for existence of INSTAT.DSK to see if that's the case.
IF EXIST INSTAT.DSK GOTO InvDrive

CD \
MD XXXYYYZZ.III  > NUL
COPY %1PKUNZIP.EXE XXXYYYZZ.III > NUL

REM ~[980086] On some systems (e.g. NT) it's just not possible to create a directory in \
REM ~ ref [980037]

IF NOT EXIST XXXYYYZZ.III\PKUNZIP.EXE GOTO TryTemp
CD XXXYYYZZ.III  > NUL
GOTO Continue

REM Try TEMP check if it's a writable directory. You may get 'Unable to create ...' or '
REM Path not Found...' messages). This is to avoid using IF EXIST %TEMP\NUL which may
REM not be portable

:TryTemp
IF x%TEMP% == x GOTO NoTemp

MD %TEMP%\XXXYYYZZ.III > NUL
COPY %1PKUNZIP.EXE %TEMP%\XXXYYYZZ.III > NUL

IF NOT EXIST %TEMP%\XXXYYYZZ.III\PKUNZIP.EXE GOTO NoTemp

REM Select drive and directory of TEMP
COPY %1CHDRIVE.BAT %TEMP%\XXXYYYZZ.III > NUL
CALL %1CHDRIVE %TEMP%\XXXYYYZZ.III > NUL
GOTO Continue

:NoTemp
CLS
CALL %1TEXT 13
PAUSE

GOTO End
REM ~[980086] End change


REM ************************************************************************
REM       Installation of application
REM ************************************************************************


:Continue
CLS
REM ~[980086]
IF EXIST %1IDEPCN8.ROM COPY %1IDEPCN8.ROM > NUL

COPY %1INSTALL.bat > NUL
COPY %1TEXT.BAT    > NUL

CALL TEXT 2

PKUNZIP -o -3 %1INSTALL  > NUL

:Proceed

INSTALL %1 %2 1

:StartInst
IDCNINST.EXE %1 %2 0 1

REM ~[970174] Not useful
REM CD \XXXYYYZZ.III

DEL PKUNZIP.EXE  > NUL
DEL *.MEM  > NUL
DEL IDCNINST.EXE  > NUL
REM ~[960206] IDCNINST.OVL does not exist anymore.
REM ~ DEL IDCNINST.OVL > NUL
DEL I_*.DB*  > NUL
DEL *.NSX  > NUL

REM ~[980086]
IF EXIST IDEPCN8.ROM DEL IDEPCN8.ROM > NUL

REM Not useful
REM IF NOT EXIST ZIP_EX.ZIP GOTO REMDIR
REM DEL ZIP_EX.ZIP > NUL

:REMDIR

Cls
CALL TEXT 3
Pause
Cls


REM ~[970174] Remdir is on the hdd or floppy
IF EXIST ..\REMDIR.BAT ..\REMDIR %1 HDD
REM use %1REMDIR i.s.o %1\REMDIR
IF NOT EXIST ..\REMDIR.BAT %1REMDIR %2 FLOPPY

GOTO end

REM ************************************************************************
REM       Error handling routine in case of erroneous input parameters
REM ************************************************************************

REM ~[980086] Can't write to CD!
:CDNotOK
Cls
CALL TEXT 6
GOTO end

:ERROR

REM ~[970174]
IF NOT EXIST TEXT.BAT GOTO BadInst

Cls
CALL TEXT 6

GOTO end

:ERROR2

REM Useless
REM DEL PKUNZIP.EXE  > NUL

REM ~[970174]
CD ..
RD XXXYYYZZ.III  > NUL
Cls

REM ~[970174]
IF NOT EXIST TEXT.BAT GOTO BadInst

CALL TEXT 7

GOTO end

REM ~[970174] Something is really wrong.

:BadInst
REM ~[980242] You may want to translate this message! See text 14 in text.bat
ECHO 
ECHO.
ECHO  Installation aborted.
ECHO  IDEP/CN8 Installation kit incomplete or missing.
ECHO.
ECHO.
Echo.
ECHO Please check that the current directory on the '%1' drive does contain the
ECHO IDEP/CN8 Installation kit and that no files are missing.
ECHO.
ECHO 

GOTO end

REM ~[990056]
:InvDrive
CLS
IF NOT EXIST %1TEXT.BAT GOTO BadInst
CALL TEXT 7

GOTO END

REM ~[980242] Better message
:BadHdd
CLS
IF NOT EXIST %1TEXT.BAT GOTO BadInst
CALL TEXT 14 %1

:end
